> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Grant permissions on a report to users or teams

POST https://api.sigmacomputing.com/v2/reports/{reportId}/grants
Content-Type: application/json

You can use this endpoint to grant specific document permissions on a specific report to users or teams.

   ### Usage notes

   - Ensure the **reportId** in the path is valid and that the user has rights to modify its permissions. Retrieve the **reportId** by calling the [/v2/reports](https://help.sigmacomputing.com/reference/list-reports) endpoint.
   - Do not set both **memberId** and **teamId** in the same **grantee** object. Instead, choose one based on the target of the grant.

     - Retrieve the **memberId** by calling the [/v2/members](https://help.sigmacomputing.com/reference/list-members) endpoint.
     - Retrieve the **teamId** by calling the [/v2/teams](https://help.sigmacomputing.com/reference/list-teams) endpoint.
   - Grant permissions on a specific version tag of a report by specifying the **tagId**. Retrieve the **tagId** by calling the [/v2/tags](https://help.sigmacomputing.com/reference/list-version-tag) endpoint and using the `versionTagId` in the response.

   ### Usage scenarios

   - **Team collaboration**: Granting edit permissions to a team for collaborative work on a project.
   - **External access sharing**: Providing view access to an external consultant.

   ### Best practices

   - Validate user and team IDs before submitting them in a request to avoid errors.
   - Use the **tagId** to help manage and revoke grants systematically as project requirements change.

Reference: https://help.sigmacomputing.com/reference/create-report-grant

## Authentication

- OAuth2 — send the obtained token as `Authorization: Bearer <token>`

## Servers

- `https://api.sigmacomputing.com` (Server for GCP (US) hosted organizations, default)
- `https://api.sa.gcp.sigmacomputing.com` (Server for GCP (KSA) hosted organizations)
- `https://aws-api.sigmacomputing.com` (Server for AWS US (West) hosted organizations)
- `https://api.us-a.aws.sigmacomputing.com` (Server for AWS US (East) hosted organizations)
- `https://api.ca.aws.sigmacomputing.com` (Server for AWS Canada hosted organizations)
- `https://api.eu.aws.sigmacomputing.com` (Server for AWS Europe hosted organizations)
- `https://api.au.aws.sigmacomputing.com` (Server for AWS Australia and APAC hosted organizations)
- `https://api.uk.aws.sigmacomputing.com` (Server for AWS UK hosted organizations)
- `https://api.us.azure.sigmacomputing.com` (Server for Azure US hosted organizations)
- `https://api.eu.azure.sigmacomputing.com` (Server for Azure Europe hosted organizations)
- `https://api.ca.azure.sigmacomputing.com` (Server for Azure Canada hosted organizations)
- `https://api.uk.azure.sigmacomputing.com` (Server for Azure United Kingdom hosted organizations)
- `https://api.au.azure.sigmacomputing.com` (Server for Azure Australia hosted organizations)

## Request

### Path parameters

- `reportId` (string, required) — Unique identifier of the report.

### Body (application/json)

This endpoint expects an object.

- `grants` (list of object, required)
  - `grantee` (object or object, required)
    - Member
      - `memberId` (string, required)
    - Team
      - `teamId` (string, required)
  - `permission` (enum, required) — Permission to grant for access to the report.
    - Allowed values: `view`, `edit`
  - `tagId` (string, optional)

## Response

### 200

The response body.

## Examples

**Request**

```json
{
  "grants": [
    {
      "grantee": {
        "memberId": "string"
      },
      "permission": "view"
    }
  ]
}
```

**Response**

```json
{}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/reports/reportId/grants"

payload = { "grants": [
        {
            "grantee": { "memberId": "string" },
            "permission": "view"
        }
    ] }
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/reports/reportId/grants';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"grants":[{"grantee":{"memberId":"string"},"permission":"view"}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/reports/reportId/grants"

	payload := strings.NewReader("{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"string\"\n      },\n      \"permission\": \"view\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/reports/reportId/grants")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"string\"\n      },\n      \"permission\": \"view\"\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/reports/reportId/grants")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"string\"\n      },\n      \"permission\": \"view\"\n    }\n  ]\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/reports/reportId/grants', [
  'body' => '{
  "grants": [
    {
      "grantee": {
        "memberId": "string"
      },
      "permission": "view"
    }
  ]
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/reports/reportId/grants");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"grants\": [\n    {\n      \"grantee\": {\n        \"memberId\": \"string\"\n      },\n      \"permission\": \"view\"\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = ["grants": [
    [
      "grantee": ["memberId": "string"],
      "permission": "view"
    ]
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/reports/reportId/grants")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```